create_clock -name clk_fpga_1 -period 10.000 [get_pins -hier * -filter {NAME =~ */ps/PS7_i/FCLKCLK[1]}]

# constraints
# ad9361 (SWAP == 0x1)

set_property  -dict {PACKAGE_PIN  L12  IOSTANDARD LVCMOS18 } [get_ports rx_clk_in]
set_property  -dict {PACKAGE_PIN  N13  IOSTANDARD LVCMOS18 } [get_ports rx_frame_in]
set_property  -dict {PACKAGE_PIN  H14  IOSTANDARD LVCMOS18 } [get_ports rx_data_in_0]
set_property  -dict {PACKAGE_PIN  J13  IOSTANDARD LVCMOS18 } [get_ports rx_data_in_1]
set_property  -dict {PACKAGE_PIN  G14  IOSTANDARD LVCMOS18 } [get_ports rx_data_in_2]
set_property  -dict {PACKAGE_PIN  H13  IOSTANDARD LVCMOS18 } [get_ports rx_data_in_3]
set_property  -dict {PACKAGE_PIN  G12  IOSTANDARD LVCMOS18 } [get_ports rx_data_in_4]
set_property  -dict {PACKAGE_PIN  H12  IOSTANDARD LVCMOS18 } [get_ports rx_data_in_5]
set_property  -dict {PACKAGE_PIN  G11  IOSTANDARD LVCMOS18 } [get_ports rx_data_in_6]
set_property  -dict {PACKAGE_PIN  J14  IOSTANDARD LVCMOS18 } [get_ports rx_data_in_7]
set_property  -dict {PACKAGE_PIN  J15  IOSTANDARD LVCMOS18 } [get_ports rx_data_in_8]
set_property  -dict {PACKAGE_PIN  K15  IOSTANDARD LVCMOS18 } [get_ports rx_data_in_9]
set_property  -dict {PACKAGE_PIN  H11  IOSTANDARD LVCMOS18 } [get_ports rx_data_in_10]
set_property  -dict {PACKAGE_PIN  J11  IOSTANDARD LVCMOS18 } [get_ports rx_data_in_11]

set_property  -dict {PACKAGE_PIN  P10  IOSTANDARD LVCMOS18} [get_ports tx_clk_out]
set_property  -dict {PACKAGE_PIN  L14  IOSTANDARD LVCMOS18} [get_ports tx_frame_out]
set_property  -dict {PACKAGE_PIN  P15  IOSTANDARD LVCMOS18} [get_ports tx_data_out_0]
set_property  -dict {PACKAGE_PIN  R13  IOSTANDARD LVCMOS18} [get_ports tx_data_out_1]
set_property  -dict {PACKAGE_PIN  R15  IOSTANDARD LVCMOS18} [get_ports tx_data_out_2]
set_property  -dict {PACKAGE_PIN  P11  IOSTANDARD LVCMOS18} [get_ports tx_data_out_3]
set_property  -dict {PACKAGE_PIN  R11  IOSTANDARD LVCMOS18} [get_ports tx_data_out_4]
set_property  -dict {PACKAGE_PIN  R12  IOSTANDARD LVCMOS18} [get_ports tx_data_out_5]
set_property  -dict {PACKAGE_PIN  P14  IOSTANDARD LVCMOS18} [get_ports tx_data_out_6]
set_property  -dict {PACKAGE_PIN  P13  IOSTANDARD LVCMOS18} [get_ports tx_data_out_7]
set_property  -dict {PACKAGE_PIN  N9   IOSTANDARD LVCMOS18} [get_ports tx_data_out_8]
set_property  -dict {PACKAGE_PIN  M9   IOSTANDARD LVCMOS18} [get_ports tx_data_out_9]
set_property  -dict {PACKAGE_PIN  R8   IOSTANDARD LVCMOS18} [get_ports tx_data_out_10]
set_property  -dict {PACKAGE_PIN  R7   IOSTANDARD LVCMOS18} [get_ports tx_data_out_11]

set_property  -dict {PACKAGE_PIN  L15  IOSTANDARD LVCMOS18} [get_ports gpio_status[0]]
set_property  -dict {PACKAGE_PIN  M15  IOSTANDARD LVCMOS18} [get_ports gpio_status[1]]
set_property  -dict {PACKAGE_PIN  N11  IOSTANDARD LVCMOS18} [get_ports gpio_status[2]]
set_property  -dict {PACKAGE_PIN  N12  IOSTANDARD LVCMOS18} [get_ports gpio_status[3]]
set_property  -dict {PACKAGE_PIN  M10  IOSTANDARD LVCMOS18} [get_ports gpio_status[4]]
set_property  -dict {PACKAGE_PIN  M11  IOSTANDARD LVCMOS18} [get_ports gpio_status[5]]
set_property  -dict {PACKAGE_PIN  N7   IOSTANDARD LVCMOS18} [get_ports gpio_status[6]]
set_property  -dict {PACKAGE_PIN  N8   IOSTANDARD LVCMOS18} [get_ports gpio_status[7]]

set_property  -dict {PACKAGE_PIN  F13  IOSTANDARD LVCMOS18} [get_ports gpio_ctl[0]]
set_property  -dict {PACKAGE_PIN  F14  IOSTANDARD LVCMOS18} [get_ports gpio_ctl[1]]
set_property  -dict {PACKAGE_PIN  G15  IOSTANDARD LVCMOS18} [get_ports gpio_ctl[2]]
set_property  -dict {PACKAGE_PIN  F15  IOSTANDARD LVCMOS18} [get_ports gpio_ctl[3]]

set_property  -dict {PACKAGE_PIN  L13  IOSTANDARD LVCMOS18} [get_ports gpio_en_agc]
set_property  -dict {PACKAGE_PIN  P9   IOSTANDARD LVCMOS18} [get_ports gpio_resetb]

set_property  -dict {PACKAGE_PIN  K12  IOSTANDARD LVCMOS18} [get_ports enable]
set_property  -dict {PACKAGE_PIN  K11  IOSTANDARD LVCMOS18} [get_ports txnrx]

set_property  -dict {PACKAGE_PIN  M14  IOSTANDARD LVCMOS18 PULLTYPE PULLUP} [get_ports iic_scl]
set_property  -dict {PACKAGE_PIN  N14  IOSTANDARD LVCMOS18 PULLTYPE PULLUP} [get_ports iic_sda]

set_property  -dict {PACKAGE_PIN  E12  IOSTANDARD LVCMOS18  PULLTYPE PULLUP} [get_ports spi_csn]
set_property  -dict {PACKAGE_PIN  E11  IOSTANDARD LVCMOS18} [get_ports spi_clk]
set_property  -dict {PACKAGE_PIN  E13  IOSTANDARD LVCMOS18} [get_ports spi_mosi]
set_property  -dict {PACKAGE_PIN  F12  IOSTANDARD LVCMOS18} [get_ports spi_miso]

set_property  -dict {PACKAGE_PIN  K13  IOSTANDARD LVCMOS18} [get_ports gpio_bd]
set_property  -dict {PACKAGE_PIN  P8   IOSTANDARD LVCMOS18} [get_ports clk_out]

# probably gone in 2016.4

set_input_jitter clk_fpga_0 0.3
set_input_jitter clk_fpga_1 0.15

set_property IOSTANDARD LVCMOS18 [get_ports *fixed_io_mio*]
set_property SLEW SLOW [get_ports *fixed_io_mio*]
set_property DRIVE 8 [get_ports *fixed_io_mio*]
set_property  -dict {PACKAGE_PIN D8   PULLTYPE PULLUP} [get_ports fixed_io_mio[ 0]]
set_property  -dict {PACKAGE_PIN A5   PULLTYPE PULLUP} [get_ports fixed_io_mio[ 1]]
set_property  -dict {PACKAGE_PIN A8                  } [get_ports fixed_io_mio[ 2]]
set_property  -dict {PACKAGE_PIN A7                  } [get_ports fixed_io_mio[ 3]]
set_property  -dict {PACKAGE_PIN C8                  } [get_ports fixed_io_mio[ 4]]
set_property  -dict {PACKAGE_PIN A9                  } [get_ports fixed_io_mio[ 5]]
set_property  -dict {PACKAGE_PIN A10                 } [get_ports fixed_io_mio[ 6]]
set_property  -dict {PACKAGE_PIN D9                  } [get_ports fixed_io_mio[ 7]]
set_property  -dict {PACKAGE_PIN B6                  } [get_ports fixed_io_mio[ 8]]
set_property  -dict {PACKAGE_PIN B5   PULLTYPE PULLUP} [get_ports fixed_io_mio[ 9]]
set_property  -dict {PACKAGE_PIN D6   PULLTYPE PULLUP} [get_ports fixed_io_mio[10]]
set_property  -dict {PACKAGE_PIN B10  PULLTYPE PULLUP} [get_ports fixed_io_mio[11]]
set_property  -dict {PACKAGE_PIN B7   PULLTYPE PULLUP} [get_ports fixed_io_mio[12]]
set_property  -dict {PACKAGE_PIN C6   PULLTYPE PULLUP} [get_ports fixed_io_mio[13]]
set_property  -dict {PACKAGE_PIN B9   PULLTYPE PULLUP} [get_ports fixed_io_mio[14]]
set_property  -dict {PACKAGE_PIN D10  PULLTYPE PULLUP} [get_ports fixed_io_mio[15]]
set_property  -dict {PACKAGE_PIN A15  PULLTYPE PULLUP} [get_ports fixed_io_mio[16]]
set_property  -dict {PACKAGE_PIN D11  PULLTYPE PULLUP} [get_ports fixed_io_mio[17]]
set_property  -dict {PACKAGE_PIN B15  PULLTYPE PULLUP} [get_ports fixed_io_mio[18]]
set_property  -dict {PACKAGE_PIN C12  PULLTYPE PULLUP} [get_ports fixed_io_mio[19]]
set_property  -dict {PACKAGE_PIN E15  PULLTYPE PULLUP} [get_ports fixed_io_mio[20]]
set_property  -dict {PACKAGE_PIN C11  PULLTYPE PULLUP} [get_ports fixed_io_mio[21]]
set_property  -dict {PACKAGE_PIN D15  PULLTYPE PULLUP} [get_ports fixed_io_mio[22]]
set_property  -dict {PACKAGE_PIN A14  PULLTYPE PULLUP} [get_ports fixed_io_mio[23]]
set_property  -dict {PACKAGE_PIN B14  PULLTYPE PULLUP} [get_ports fixed_io_mio[24]]
set_property  -dict {PACKAGE_PIN C14  PULLTYPE PULLUP} [get_ports fixed_io_mio[25]]
set_property  -dict {PACKAGE_PIN A13  PULLTYPE PULLUP} [get_ports fixed_io_mio[26]]
set_property  -dict {PACKAGE_PIN D14  PULLTYPE PULLUP} [get_ports fixed_io_mio[27]]
set_property  -dict {PACKAGE_PIN B12  PULLTYPE PULLUP} [get_ports fixed_io_mio[28]]
set_property  -dict {PACKAGE_PIN D13  PULLTYPE PULLUP} [get_ports fixed_io_mio[29]]
set_property  -dict {PACKAGE_PIN A12  PULLTYPE PULLUP} [get_ports fixed_io_mio[30]]
set_property  -dict {PACKAGE_PIN C13  PULLTYPE PULLUP} [get_ports fixed_io_mio[31]]

set_property IOSTANDARD LVCMOS18 [get_ports *fixed_io_ps*]
set_property SLEW SLOW [get_ports *fixed_io_ps*]
set_property DRIVE 8 [get_ports *fixed_io_ps*]
set_property PACKAGE_PIN C7 [get_ports fixed_io_ps_clk]
set_property PACKAGE_PIN C9 [get_ports fixed_io_ps_porb]

set_property IOSTANDARD SSTL15_T_DCI [get_ports *fixed_io_ddr_vr*]
set_property SLEW FAST [get_ports *fixed_io_ddr_vr*]
set_property PACKAGE_PIN H3 [get_ports fixed_io_ddr_vrp]
set_property PACKAGE_PIN J3 [get_ports fixed_io_ddr_vrn]

set_property IOSTANDARD DIFF_SSTL15 [get_ports *ddr_ck*]
set_property SLEW FAST [get_ports *ddr_ck*]
set_property PACKAGE_PIN N3 [get_ports ddr_ck_p]
set_property PACKAGE_PIN N2 [get_ports ddr_ck_n]

set_property IOSTANDARD SSTL15 [get_ports *ddr_addr*]
set_property SLEW SLOW [get_ports *ddr_addr*]
set_property PACKAGE_PIN P1 [get_ports ddr_addr[0]]
set_property PACKAGE_PIN N1 [get_ports ddr_addr[1]]
set_property PACKAGE_PIN M1 [get_ports ddr_addr[2]]
set_property PACKAGE_PIN M4 [get_ports ddr_addr[3]]
set_property PACKAGE_PIN P3 [get_ports ddr_addr[4]]
set_property PACKAGE_PIN P4 [get_ports ddr_addr[5]]
set_property PACKAGE_PIN P5 [get_ports ddr_addr[6]]
set_property PACKAGE_PIN M5 [get_ports ddr_addr[7]]
set_property PACKAGE_PIN P6 [get_ports ddr_addr[8]]
set_property PACKAGE_PIN N4 [get_ports ddr_addr[9]]
set_property PACKAGE_PIN J1 [get_ports ddr_addr[10]]
set_property PACKAGE_PIN L2 [get_ports ddr_addr[11]]
set_property PACKAGE_PIN M2 [get_ports ddr_addr[12]]
set_property PACKAGE_PIN K2 [get_ports ddr_addr[13]]
set_property PACKAGE_PIN K1 [get_ports ddr_addr[14]]

set_property IOSTANDARD SSTL15 [get_ports *ddr_ba*]
set_property SLEW SLOW [get_ports *ddr_ba*]
set_property PACKAGE_PIN M6 [get_ports ddr_ba[0]]
set_property PACKAGE_PIN R1 [get_ports ddr_ba[1]]
set_property PACKAGE_PIN N6 [get_ports ddr_ba[2]]

set_property IOSTANDARD SSTL15 [get_ports ddr_reset_n]
set_property SLEW FAST [get_ports ddr_reset_n]
set_property PACKAGE_PIN L4 [get_ports ddr_reset_n]
set_property IOSTANDARD SSTL15 [get_ports ddr_cs_n]
set_property SLEW SLOW [get_ports ddr_cs_n]
set_property PACKAGE_PIN R2 [get_ports ddr_cs_n]
set_property IOSTANDARD SSTL15 [get_ports ddr_ras_n]
set_property SLEW SLOW [get_ports ddr_ras_n]
set_property PACKAGE_PIN R6 [get_ports ddr_ras_n]
set_property IOSTANDARD SSTL15 [get_ports ddr_cas_n]
set_property SLEW SLOW [get_ports ddr_cas_n]
set_property PACKAGE_PIN R5 [get_ports ddr_cas_n]
set_property IOSTANDARD SSTL15 [get_ports ddr_we_n]
set_property SLEW SLOW [get_ports ddr_we_n]
set_property PACKAGE_PIN R3 [get_ports ddr_we_n]
set_property IOSTANDARD SSTL15 [get_ports ddr_cke]
set_property SLEW SLOW [get_ports ddr_cke]
set_property PACKAGE_PIN L3 [get_ports ddr_cke]
set_property IOSTANDARD SSTL15 [get_ports ddr_odt]
set_property SLEW SLOW [get_ports ddr_odt]
set_property PACKAGE_PIN K3 [get_ports ddr_odt]

set_property IOSTANDARD SSTL15_T_DCI [get_ports *ddr_dq[*]]
set_property SLEW FAST [get_ports *ddr_dq[*]]
set_property PACKAGE_PIN D4 [get_ports ddr_dq[0]]
set_property PACKAGE_PIN A2 [get_ports ddr_dq[1]]
set_property PACKAGE_PIN C4 [get_ports ddr_dq[2]]
set_property PACKAGE_PIN C1 [get_ports ddr_dq[3]]
set_property PACKAGE_PIN B4 [get_ports ddr_dq[4]]
set_property PACKAGE_PIN A4 [get_ports ddr_dq[5]]
set_property PACKAGE_PIN C3 [get_ports ddr_dq[6]]
set_property PACKAGE_PIN A3 [get_ports ddr_dq[7]]
set_property PACKAGE_PIN E1 [get_ports ddr_dq[8]]
set_property PACKAGE_PIN D1 [get_ports ddr_dq[9]]
set_property PACKAGE_PIN E2 [get_ports ddr_dq[10]]
set_property PACKAGE_PIN E3 [get_ports ddr_dq[11]]
set_property PACKAGE_PIN F3 [get_ports ddr_dq[12]]
set_property PACKAGE_PIN G1 [get_ports ddr_dq[13]]
set_property PACKAGE_PIN H1 [get_ports ddr_dq[14]]
set_property PACKAGE_PIN H2 [get_ports ddr_dq[15]]
set_property IOSTANDARD SSTL15_T_DCI [get_ports *ddr_dm[*]]
set_property SLEW FAST [get_ports *ddr_dm[*]]
set_property PACKAGE_PIN B1 [get_ports ddr_dm[0]]
set_property PACKAGE_PIN D3 [get_ports ddr_dm[1]]
set_property IOSTANDARD DIFF_SSTL15_T_DCI [get_ports *ddr_dqs*]
set_property SLEW FAST [get_ports *ddr_dqs*]
set_property PACKAGE_PIN C2 [get_ports ddr_dqs_p[0]]
set_property PACKAGE_PIN B2 [get_ports ddr_dqs_n[0]]
set_property PACKAGE_PIN G2 [get_ports ddr_dqs_p[1]]
set_property PACKAGE_PIN F2 [get_ports ddr_dqs_n[1]]

# ad9361_data_sub_FB_CLK_P is the data clock from AD9361, sample rate dependent with a max rate of 61.44MHz
set data_clk_period 16.276;
create_clock -name ad9361_data_clk -period $data_clk_period [get_ports tx_clk_out] 

# Asynchronous clock domains
set_clock_groups -asynchronous \
  -group [get_clocks -include_generated_clocks ad9361_data_clk] \
  -group [get_clocks -include_generated_clocks clk_fpga_1]

# Setup ADC (AD9361) interface constraints.
# ----- assumed ad9361_data_sub.hdl parameter property/no-OS init_param settings
# ----- (values chosen specifically to meet static timing):
# ------------------------------------------------------------------------------
# | ad9361_data_sub.hdl | no-OS init_param member | value | delay(ns)          |
# | parameter property  |                         |       |                    |
# ------------------------------------------------------------------------------
# | DATA_CLK_Delay      | rx_data_clock_delay     | 7     | 2.1                |
# | Rx_Data_Delay       | rx_data_delay           | 0     | 0.0                |
# ------------------------------------------------------------------------------
#
# ----- calculations
# skew_bre = -t_DDRx_min + (DATA_CLK_Delay-Rx_Data_Delay)*0.3 = 0.63
# Rise Min = (period/2) - skew_bfe = (16.276/2) - 0.63 = 7.508
# t_DDRx_min = 0
set min_rx_delay 7.508
# t_DDRx_max = 1.5 (Table 49 of UG-570 for 1.8V supply - Rx Data Delay from DATA_CLK to data pins)
set max_rx_delay [expr $min_rx_delay + 1.5]
# t_DDRv_min = 0
set min_rx_frame_delay $min_rx_delay
# t_DDRv_max = 1.0 (Rx Data Delay from DATA_CLK to RX_FRAME)
set max_rx_frame_delay [expr $min_rx_delay + 1]

set_input_delay -clock [get_clocks ad9361_data_clk] -max $max_rx_frame_delay [get_ports {rx_frame_in}]
set_input_delay -clock [get_clocks ad9361_data_clk] -min $min_rx_frame_delay [get_ports {rx_frame_in}]
set_input_delay -clock [get_clocks ad9361_data_clk] -max $max_rx_frame_delay [get_ports {rx_frame_in}] -clock_fall -add_delay
set_input_delay -clock [get_clocks ad9361_data_clk] -min $min_rx_frame_delay [get_ports {rx_frame_in}] -clock_fall -add_delay

# because RX_FRAME_P is sampled on the DATA_CLK_P falling edge (we use DDR primitive as a sample-in-the-middle), the rising edge latched output is unconnected and therefore should not be used in timing analysis
set_false_path -from [get_ports rx_frame_in] -rise_to [get_pins ftop/pfconfig_i/ad9361_adc_sub_i/worker/supported_so_far.rx_frame_p_ddr/D]

###############################################################################
## Asynchronous paths
###############################################################################
set_false_path -from [get_ports ONSWITCH_DB]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -min -add_delay $min_rx_delay [get_ports {rx_data_in_0}]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -max -add_delay $max_rx_delay [get_ports {rx_data_in_0}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -min -add_delay $min_rx_delay [get_ports {rx_data_in_0}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -max -add_delay $max_rx_delay [get_ports {rx_data_in_0}]

set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -min -add_delay $min_rx_delay [get_ports {rx_data_in_1}]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -max -add_delay $max_rx_delay [get_ports {rx_data_in_1}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -min -add_delay $min_rx_delay [get_ports {rx_data_in_1}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -max -add_delay $max_rx_delay [get_ports {rx_data_in_1}]

set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -min -add_delay $min_rx_delay [get_ports {rx_data_in_2}]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -max -add_delay $max_rx_delay [get_ports {rx_data_in_2}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -min -add_delay $min_rx_delay [get_ports {rx_data_in_2}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -max -add_delay $max_rx_delay [get_ports {rx_data_in_2}]

set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -min -add_delay $min_rx_delay [get_ports {rx_data_in_3}]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -max -add_delay $max_rx_delay [get_ports {rx_data_in_3}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -min -add_delay $min_rx_delay [get_ports {rx_data_in_3}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -max -add_delay $max_rx_delay [get_ports {rx_data_in_3}]

set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -min -add_delay $min_rx_delay [get_ports {rx_data_in_4}]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -max -add_delay $max_rx_delay [get_ports {rx_data_in_4}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -min -add_delay $min_rx_delay [get_ports {rx_data_in_4}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -max -add_delay $max_rx_delay [get_ports {rx_data_in_4}]

set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -min -add_delay $min_rx_delay [get_ports {rx_data_in_5}]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -max -add_delay $max_rx_delay [get_ports {rx_data_in_5}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -min -add_delay $min_rx_delay [get_ports {rx_data_in_5}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -max -add_delay $max_rx_delay [get_ports {rx_data_in_5}]

set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -min -add_delay $min_rx_delay [get_ports {rx_data_in_6}]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -max -add_delay $max_rx_delay [get_ports {rx_data_in_6}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -min -add_delay $min_rx_delay [get_ports {rx_data_in_6}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -max -add_delay $max_rx_delay [get_ports {rx_data_in_6}]

set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -min -add_delay $min_rx_delay [get_ports {rx_data_in_7}]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -max -add_delay $max_rx_delay [get_ports {rx_data_in_7}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -min -add_delay $min_rx_delay [get_ports {rx_data_in_7}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -max -add_delay $max_rx_delay [get_ports {rx_data_in_7}]

set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -min -add_delay $min_rx_delay [get_ports {rx_data_in_8}]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -max -add_delay $max_rx_delay [get_ports {rx_data_in_8}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -min -add_delay $min_rx_delay [get_ports {rx_data_in_8}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -max -add_delay $max_rx_delay [get_ports {rx_data_in_8}]

set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -min -add_delay $min_rx_delay [get_ports {rx_data_in_9}]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -max -add_delay $max_rx_delay [get_ports {rx_data_in_9}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -min -add_delay $min_rx_delay [get_ports {rx_data_in_9}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -max -add_delay $max_rx_delay [get_ports {rx_data_in_9}]

set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -min -add_delay $min_rx_delay [get_ports {rx_data_in_10}]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -max -add_delay $max_rx_delay [get_ports {rx_data_in_10}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -min -add_delay $min_rx_delay [get_ports {rx_data_in_10}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -max -add_delay $max_rx_delay [get_ports {rx_data_in_10}]

set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -min -add_delay $min_rx_delay [get_ports {rx_data_in_11}]
set_input_delay -clock [get_clocks {ad9361_data_clk}] -clock_fall -max -add_delay $max_rx_delay [get_ports {rx_data_in_11}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -min -add_delay $min_rx_delay [get_ports {rx_data_in_11}]
set_input_delay -clock [get_clocks {ad9361_data_clk}]             -max -add_delay $max_rx_delay [get_ports {rx_data_in_11}]
